﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml;
using System.Xml.Serialization;
using System.Collections;


    public class LoginCredentials
    {
        public string UserName { get; set; }
        public string Password { get; set; }
        public string Auxiliary { get; set; }
    }

    public class AddressData
    {

        public string Number { get; set; }
        public string Name1 { get; set; }
        public string Name2 { get; set; }
        public string StreetAddress1 { get; set; }
        public string StreetAddress2 { get; set; }
        public string StreetAddress3 { get; set; }
        public string Postcode { get; set; }
        public string City { get; set; }
        public string Mobile { get; set; }
        public string Phone { get; set; }
        public string Email { get; set; }
        public string Fax { get; set; }
        public string PostOfficeBox { get; set; }
        public string PostOfficeBoxCity { get; set; }
        public string PostOfficeBoxPostcode { get; set; }
        public string CountryName { get; set; }
        public string CustomerOrigin { get; set; }
        public string Attention { get; set; }
        public string Contact { get; set; }
        public string ReceiverRef { get; set; }
        public string OurRef { get; set; }
        public string MessageToCarrier { get; set; }
        public string MessageToDriver { get; set; }
        public string MessageToReceiver { get; set; }
        public string PurchaseNo { get; set; }
        public string ShipmentTypeNo { get; set; }
        public string DeliveryConditions { get; set; }
        public string DeliveryTime { get; set; }
        public string PaymentTerms { get; set; }
        public string Amount { get; set; }
        public string Account { get; set; }
        public string Reference { get; set; }
        public AddressType Type { get; set; }

    }


    public class LineData
    {

        public int PackagesCount { get; set; }
        public string PackagesMarking { get; set; }
        public string PackagesContents { get; set; }
        public int PackagesWeight { get; set; }
        public int PackagesHeight { get; set; }
        public int PackagesLength { get; set; }
        public int PackagesWidth { get; set; }
        public int PackagesVolume { get; set; }
        public string CODAccount { get; set; }
        public string CODAmount { get; set; }
        public string CODKID { get; set; }
        public string CODReference { get; set; }
        public string InsuranceAmount { get; set; }
        public string InsuranceCategory { get; set; }
        public string InsurancePolicyNo { get; set; }
        public string DeliveryTerms { get; set; }
        public string Department { get; set; }
        public string InvoiceNumber { get; set; }
        public string PaymentTerms { get; set; }
        public string PaymentType { get; set; }
        public string ProjectName { get; set; }
        public string ProjectNumber { get; set; }
        public string CarrierCode { get; set; }

    }

    public class AddressesAndPackages
    {
        public List<AddressData> Addresses = new List<AddressData>();
        public List<LineData> Packages = new List<LineData>();
    }



    public class ReturnData
    {
        public string OrderNumber { get; set; }
        public int PackagesCount { get; set; }
        public string ShipmentNumber { get; set; }
        public string ShipmentTrackUrl { get; set; }
        public string ColliNumbers { get; set; }
        public string PackageTrackUrl { get; set; }
        public string Carrier { get; set; }
        public string Product { get; set; }
        public double Price1 { get; set; }
        public double Price2 { get; set; }
       
    }


    public enum AddressType
    {
        Customer,
        Order,
        Order2,
        Delivery,
        Invoice,
        Contact
    }

