﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data.Odbc;
using System.Data;
using System.Configuration;
using System.Xml.Serialization;
using System.Collections;
using System.Web.Services.Protocols;
using MySql.Data.MySqlClient;
using System.Data.SqlClient;
using System.IO;



[WebService(Namespace = "http://YourDomain.com/ESWebIntegrationWS.asmx")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class ESWebIntegrationWS : System.Web.Services.WebService
{
    //Get adressdata and packagedata on order
    [WebMethod(Description = "Returns an AddressesAndPackages class(AddressData and LineData as List).")]
    public AddressesAndPackages GetOrderData(string OrderNumber, LoginCredentials Credentials)
    {

        AddressesAndPackages result = new AddressesAndPackages();
        AddressData ad = new AddressData();
        LineData ld = new LineData();

        //Fetch DB prefix from function Authenticate, based on username and password or from Auxiliary.
        string strPrefix = Credentials.UserName;
        //string strPrefix = Authenticate(Credentials);


        //Connectionstring, present in web.config or code it inline.
        string strConn = ConfigurationManager.AppSettings["DBconnectionstring"];

        string strSql = "SELECT Sum(p.products_weight) as weight, " +
                "o.orders_id, " +
                "Count(op.products_id) as antall_produkter, " +
                "o.customers_country, " +
                "o.customers_id, " +
                "o.customers_telephone, " +
                "o.customers_email_address, " +
                "o.delivery_name, " +
                "o.delivery_company, " +
                "o.delivery_street_address, " +
                "o.delivery_city, " +
                "o.delivery_postcode, " +
                "o.delivery_state, " +
                "o.delivery_country, " +
                "o.billing_name, " +
                "o.billing_street_address, " +
                "o.billing_city, " +
                "o.billing_postcode, " +
                "o.billing_country, " +
                "o.payment_method, " +
                "o.date_purchased, " +
                "ot.value as total, " +
                "ott.title " +

                "FROM " +
                strPrefix + "ORDERS AS o " +
                "INNER JOIN " + strPrefix + "ORDERS_PRODUCTS AS op " +
                "ON o.orders_id = op.orders_id " +
                "LEFT JOIN " + strPrefix + "PRODUCTS AS p " +
                "ON op.products_id = p.products_id " +
                "INNER JOIN " + strPrefix + "ORDERS_TOTAL AS ot " +
                "ON o.orders_id = ot.orders_id " +
                "INNER JOIN " + strPrefix + "ORDERS_TOTAL AS ott " +
                "ON o.orders_id = ott.orders_id " +

                "WHERE " +
                "o.orders_id =" + OrderNumber +
                " AND ot.class = 'ot_total' " +
                " AND ott.class = 'ot_shipping' " +

                "GROUP BY " +
                "o.orders_id, " +
                "o.customers_country, " +
                "o.customers_telephone, " +
                "o.customers_email_address, " +
                "o.delivery_name, " +
                "o.delivery_company, " +
                "o.delivery_street_address, " +
                "o.delivery_city, " +
                "o.delivery_postcode, " +
                "o.delivery_state, " +
                "o.delivery_country, " +
                "o.billing_name, " +
                "o.billing_street_address, " +
                "o.billing_city, " +
                "o.billing_postcode, " +
                "o.billing_country, " +
                "o.payment_method, " +
                "o.date_purchased, " +
                "ot.value," +
                "ott.title";

        IDataReader dr = Reader(strSql, strConn);


        try
        {
            while (dr.Read())
            {

                ad = new AddressData();
                ad.Number = Convert.ToString(dr.GetString(dr.GetOrdinal("orders_id")));
                ad.Name1 = Convert.ToString(dr.GetString(dr.GetOrdinal("delivery_name")));
                ad.StreetAddress1 = dr.GetString(dr.GetOrdinal("delivery_street_address"));
                ad.Postcode = Convert.ToString(dr.GetString(dr.GetOrdinal("delivery_postcode")));
                ad.City = Convert.ToString(dr.GetString(dr.GetOrdinal("delivery_city")));
                ad.CountryName = Convert.ToString(dr.GetString(dr.GetOrdinal("delivery_country")));
                ad.Mobile = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_telephone")));
                ad.Email = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_email_address")));
                ad.PostOfficeBox = Convert.ToString(dr.GetString(dr.GetOrdinal("billing_street_address")));
                ad.PostOfficeBoxPostcode = Convert.ToString(dr.GetString(dr.GetOrdinal("billing_postcode")));
                ad.PostOfficeBoxCity = Convert.ToString(dr.GetString(dr.GetOrdinal("billing_city")));
                ad.CountryName = "NO";
                ad.Attention = "Attention";
                ad.Contact = "Contact";
                ad.Fax = "66545854";
                ad.MessageToCarrier = "MessageToCarrier";
                ad.MessageToDriver = "MessageToDriver";
                ad.MessageToReceiver = "MessageToreceiver";
                ad.OurRef = "OurRef";
                ad.ReceiverRef = "ReceiverRef";
                ad.Reference = "Reference";
                ad.Phone = "47565896";
                ad.Type = AddressType.Delivery;
                result.Addresses.Add(ad);

                ld = new LineData();
                ld.PackagesCount = 1;
                //ld.PackagesWeight = Convert.ToInt32(dr["weight"]);
                ld.PackagesWeight = 5000;
                ld.PackagesHeight = 200;
                ld.PackagesLength = 225;
                ld.PackagesWidth = 220;
                ld.PackagesVolume = 9900000;
                ld.PackagesMarking = "Marking";
                ld.PackagesContents = "Contents";
                ld.InsuranceAmount = "600";
                ld.CODKID = "1232545654";
                ld.CODAmount = Convert.ToString(dr.GetString(dr.GetOrdinal("total")));
                ld.PaymentTerms = Convert.ToString(dr.GetString(dr.GetOrdinal("payment_method")));
                ld.CarrierCode = Convert.ToString(dr.GetString(dr.GetOrdinal("title")));
                result.Packages.Add(ld);
            }
        }

        finally
        {
            dr.Close();
        }

        return result;
    }


    //Get adressdata on customer
    [WebMethod(Description = "Returns an array of AddressData on the customer.")]
    public AddressData[] GetCustomerData(string CustomerNumber, LoginCredentials Credentials)
    {

        AddressesAndPackages result = new AddressesAndPackages();
        ArrayList alist = new ArrayList();

        AddressData ad = new AddressData();



        //Fetch DB prefix from function Authenticate, based on username and password or from Auxiliary.
        string strPrefix = Credentials.UserName;
        //string strPrefix = Authenticate(Credentials);

        //Connectionstring, present in web.config or code it inline here.
        string strConn = ConfigurationManager.AppSettings["DBconnectionstring"];

        string strSql = "SELECT c.customers_id, " +
                        "CONCAT(a.entry_firstname, ' ', a.entry_lastname) AS Name, " +
                        "a.entry_street_address, " +
                        "a.entry_postcode, " +
                        "a.entry_city, " +
                        "c.customers_email_address, " +
                        "c.customers_telephone, " +
                        "c.customers_fax " +
                        "FROM " + strPrefix + "customers AS c " +
                        "INNER JOIN " + strPrefix + "address_book AS A " +
                        "ON c.customers_default_address_id = a.address_book_id " +
                        "WHERE c.customers_id =" + CustomerNumber;

        IDataReader dr = Reader(strSql, strConn);


        try
        {
            while (dr.Read())
            {

                ad.Number = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_id")));
                ad.Name1 = Convert.ToString(dr.GetString(dr.GetOrdinal("Name")));
                ad.StreetAddress1 = Convert.ToString(dr.GetString(dr.GetOrdinal("entry_street_address")));
                ad.Postcode = Convert.ToString(dr.GetString(dr.GetOrdinal("entry_postcode")));
                ad.City = Convert.ToString(dr.GetString(dr.GetOrdinal("entry_city")));
                ad.Mobile = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_telephone")));
                ad.Email = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_email_address")));
                ad.Fax = Convert.ToString(dr.GetString(dr.GetOrdinal("customers_fax")));
                ad.Type = AddressType.Customer;

                alist.Add(ad);
            }
        }

        finally
        {
            dr.Close();
        }
        AddressData[] outArray = (AddressData[])alist.ToArray(typeof(AddressData));

        return outArray;
    }


    //Updates database with the return data from Consignor
    [WebMethod(Description = "Updates order with the return data from Consignor.")]
    public void UpdateData(ReturnData Shipment, LoginCredentials Credentials)
    {
       //Writes returdata to file for testing
        /* 
        String Dir = "C:\\iconfig_Ticket\\test.txt";

        TextWriter tw = new StreamWriter(Dir);
        tw.WriteLine("Ordrenummer: " + Shipment.OrderNumber);
        tw.WriteLine("Antall pakker: " + Shipment.PackagesCount);
        tw.WriteLine("Pris1: " + Shipment.Price1.ToString());
        tw.WriteLine("Pris2: " + Shipment.Price2.ToString());
        tw.WriteLine("Transportør: " + Shipment.Carrier);
        tw.WriteLine("Produkt: " + Shipment.Product);
        tw.WriteLine("Sendings URL: " + Shipment.ShipmentTrackUrl);
        tw.WriteLine("Sendingsnummer: " + Shipment.ShipmentNumber);
        tw.WriteLine("Kolli URL: " + Shipment.PackageTrackUrl);
        tw.WriteLine("Kolli nummer: " + Shipment.ColliNumbers);
        tw.Close();
        */
        //Fetch DB prefix from function Authenticate, based on username and password or from Auxiliary.
        string strPrefix = Credentials.UserName;
        //string strPrefix = Authenticate(Credentials);
        
        //Connectionstring, present in web.config or code it inline here.
        string strConn = ConfigurationManager.AppSettings["DBconnectionstring"];
        string DateFormat = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
        //string comments = "Hei Din Pakke har blitt sendt: Sporingsnummeret er :";
        string comments = "Colli count: " + Shipment.PackagesCount + ", Price1: " + Shipment.Price1.ToString() + ",- " + " Price2: " + Shipment.Price2.ToString() +  ",- " + "Carrier: " + Shipment.Carrier + ",  Product: " + Shipment.Product + " T&T URL: " + Shipment.ShipmentTrackUrl;
        //Updates table Orders
        string strSqlUpdate = "UPDATE " + strPrefix + "Orders " +
                              "SET orders_status = 3, " +
                              "tracking_number= " + Shipment.ShipmentNumber +
                              " where orders_id = " + Shipment.OrderNumber;

        //Inserts new line to table orders_status_history
        string strSqlInsert = "INSERT INTO " + strPrefix + "orders_status_history (" +
        "orders_status_history_id , " +
        "orders_id , " +
        "orders_status_id , " +
        "date_added , " +
        "customer_notified , " +
        "comments , " +
        "tracking_id) " +
        "VALUES (NULL , " + Shipment.OrderNumber + ", '3'," + "'" + DateFormat + "'" + ", '0', " + "'" + comments + "'" + ", " + Shipment.ShipmentNumber + ")";

        /*Enable the database connectiontype that suits your connectionstring driver and database
      
        OdbcConnection Con = new OdbcConnection(strConn);
        OdbcCommand cmdUpdate = new OdbcCommand(strSqlUpdate, Con);
        OdbcCommand cmdInsert = new OdbcCommand(strSqlInsert, Con);
     
      
        SqlConnection Con = new SqlConnection(strConn);
        SqlCommand cmdUpdate ) new SqlCommand(strSqlUpdate, Con);
        SqlCommand cmdInsert = new SqlCommand(strSqlInsert, Con);
        */
       
        MySqlConnection Con = new MySqlConnection(strConn);
        MySqlCommand cmdUpdate = new MySqlCommand(strSqlUpdate, Con);
        MySqlCommand cmdInsert = new MySqlCommand(strSqlInsert, Con);

        Con.Open();

        //Executes SQL statements, could write a try function with try\catch to get exeptions
        cmdUpdate.ExecuteNonQuery();
        cmdInsert.ExecuteNonQuery();
        Con.Close();
       

    }

    //Fetch DB prefix based on username and password.
    private string Authenticate(LoginCredentials Credentials)
    {

        //Insert code for user authentication
        string strPre = "";

        if (Credentials.UserName == "jeff" && Credentials.Password == "jeff")
            strPre = "Shop1_store_no_";

        return strPre;

    }


    //Check if the web service is alive for Consignor
    [WebMethod(Description = "Checks the web service is currently up and available.")]
    public Boolean IsAlive()
    {
        return true;
    }




    //Creates and returns a datareader 
    public static IDataReader Reader(string Query, string Con)
    {
        /*Enable the database connectiontype that suits your connectionstring driver and database
         
        OdbcDataReader dr = null;
        OdbcConnection cn = new OdbcConnection(Con);
       
        
        SqlDataReader dr = null;
        SqlConnection cn = new SqlConnection(Con);
        */
        MySqlDataReader dr = null;
        MySqlConnection cn = new MySqlConnection(Con);


        cn.Open();
        try
        {
            //OdbcCommand cmd = new OdbcCommand(Query, cn);
            //SqlCommand cmd = new SqlCommand)Query, cn);

            MySqlCommand cmd = new MySqlCommand(Query, cn);
            dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
        }
        catch (Exception Ex)
        {
            if (dr != null)
            {
                dr.Close();
                cn.Close();
            }
            throw Ex;
        }
        return (IDataReader)dr;
    }


}

